package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.TmsTruckFeign;
import com.steerinfo.dil.service.impl.OmstruckOrderSeparateServiceImpl;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/12/3 15:07
 */

@RestController
@RequestMapping("/${api.version}/omstruckorderseparates")
public class OmstruckOrderSeparateController extends BaseRESTfulController {


    @Autowired
    OmstruckOrderSeparateServiceImpl omstruckOrderSeparateService;

    @Autowired
    private TmsTruckFeign tmsTruckFeign;

    @PostMapping("/getOrderMes")
    public RESTfulResult getMes(@RequestBody(required = false) Map<String, Object> map){
        Integer integer = tmsTruckFeign.addTotalResult(map);
        return success(integer);
    }

    /**
     * 添加退货实绩关闭当前订单
     * @param map
     * @return
     */
    @PostMapping("/returnOrderCloseOrder")
    public RESTfulResult returnOrderCloseOrder(@RequestBody(required = false) Map<String, Object> map){
        Integer result = omstruckOrderSeparateService.returnOrderCloseOrder(map);
        return success(result);
    }

    /**
     * 根据运单id查询实绩位置
     * @param map
     * @return
     */
    @PostMapping("/getOrderResult")
    public List<Map<String,Object>> getOrderResult(@RequestBody Map<String,Object> map){
        Integer orderId = (Integer) map.get("orderId");
        String orderNumber = (String) map.get("orderNumber");
        List<Map<String, Object>> result = null;
        if (orderId != null) {
            result = omstruckOrderSeparateService.getOrderResult(new BigDecimal(orderId));
        }
        else {
            result = omstruckOrderSeparateService.getOrderNumberResult(orderNumber);
        }
        return result;
    }

    /**
     * 发送消息到 websocket 推送消息
     * @param map
     */
    @PostMapping("/pushMesToWebsocket")
    public RESTfulResult pushMesToWebsocket(@RequestBody Map<String,Object> map) {
        String s = omstruckOrderSeparateService.pushMesToWebsocket(map);
        return success(s);
    }
}
